# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from google_chat_ros/KeyValue.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import google_chat_ros.msg

class KeyValue(genpy.Message):
  _md5sum = "b6a881cbd28397b27cef176bc48d6879"
  _type = "google_chat_ros/KeyValue"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """string top_label # The text of the top label
string content # The text of the content. Always required
bool content_multiline # If the content should be multiline
string bottom_label # The text of the bottom label
google_chat_ros/OnClick on_click
string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
string original_icon_url # Original icon image's url
string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
google_chat_ros/Button button # A button that can be clicked to trigger an action

================================================================================
MSG: google_chat_ros/OnClick
### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
string open_link_url # A link that opens a new window

================================================================================
MSG: google_chat_ros/FormAction
# The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
string action_method_name
google_chat_ros/ActionParameter[] parameters

================================================================================
MSG: google_chat_ros/ActionParameter
string key
string value

================================================================================
MSG: google_chat_ros/Button
### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
# A button with text and onclick action
string text_button_name 
google_chat_ros/OnClick text_button_on_click
# An image button with an onclick action
string image_button_name
google_chat_ros/OnClick image_button_on_click
string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
string original_icon_url # Original icon image's url
string original_icon_filepath # Original icon
"""
  __slots__ = ['top_label','content','content_multiline','bottom_label','on_click','icon','original_icon_url','original_icon_localpath','button']
  _slot_types = ['string','string','bool','string','google_chat_ros/OnClick','string','string','string','google_chat_ros/Button']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       top_label,content,content_multiline,bottom_label,on_click,icon,original_icon_url,original_icon_localpath,button

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KeyValue, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.top_label is None:
        self.top_label = ''
      if self.content is None:
        self.content = ''
      if self.content_multiline is None:
        self.content_multiline = False
      if self.bottom_label is None:
        self.bottom_label = ''
      if self.on_click is None:
        self.on_click = google_chat_ros.msg.OnClick()
      if self.icon is None:
        self.icon = ''
      if self.original_icon_url is None:
        self.original_icon_url = ''
      if self.original_icon_localpath is None:
        self.original_icon_localpath = ''
      if self.button is None:
        self.button = google_chat_ros.msg.Button()
    else:
      self.top_label = ''
      self.content = ''
      self.content_multiline = False
      self.bottom_label = ''
      self.on_click = google_chat_ros.msg.OnClick()
      self.icon = ''
      self.original_icon_url = ''
      self.original_icon_localpath = ''
      self.button = google_chat_ros.msg.Button()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.top_label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.content
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.content_multiline
      buff.write(_get_struct_B().pack(_x))
      _x = self.bottom_label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.on_click.action.action_method_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.on_click.action.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.on_click.action.parameters:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.on_click.open_link_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.icon
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.original_icon_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.original_icon_localpath
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.text_button_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.text_button_on_click.action.action_method_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.button.text_button_on_click.action.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.button.text_button_on_click.action.parameters:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.text_button_on_click.open_link_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.image_button_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.image_button_on_click.action.action_method_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.button.image_button_on_click.action.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.button.image_button_on_click.action.parameters:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.image_button_on_click.open_link_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.icon
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.original_icon_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.original_icon_filepath
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.on_click is None:
        self.on_click = google_chat_ros.msg.OnClick()
      if self.button is None:
        self.button = google_chat_ros.msg.Button()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.top_label = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.top_label = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.content = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.content = str[start:end]
      start = end
      end += 1
      (self.content_multiline,) = _get_struct_B().unpack(str[start:end])
      self.content_multiline = bool(self.content_multiline)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.bottom_label = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.bottom_label = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.on_click.action.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.on_click.action.action_method_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.on_click.action.parameters = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.ActionParameter()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.on_click.action.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.on_click.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.on_click.open_link_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.icon = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.icon = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.original_icon_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.original_icon_localpath = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.original_icon_localpath = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.text_button_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.text_button_on_click.action.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.text_button_on_click.action.action_method_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.button.text_button_on_click.action.parameters = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.ActionParameter()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.button.text_button_on_click.action.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.text_button_on_click.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.text_button_on_click.open_link_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.image_button_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.image_button_on_click.action.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.image_button_on_click.action.action_method_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.button.image_button_on_click.action.parameters = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.ActionParameter()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.button.image_button_on_click.action.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.image_button_on_click.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.image_button_on_click.open_link_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.icon = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.icon = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.original_icon_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.original_icon_filepath = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.top_label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.content
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.content_multiline
      buff.write(_get_struct_B().pack(_x))
      _x = self.bottom_label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.on_click.action.action_method_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.on_click.action.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.on_click.action.parameters:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.on_click.open_link_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.icon
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.original_icon_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.original_icon_localpath
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.text_button_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.text_button_on_click.action.action_method_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.button.text_button_on_click.action.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.button.text_button_on_click.action.parameters:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.text_button_on_click.open_link_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.image_button_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.image_button_on_click.action.action_method_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.button.image_button_on_click.action.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.button.image_button_on_click.action.parameters:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.image_button_on_click.open_link_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.icon
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.original_icon_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.button.original_icon_filepath
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.on_click is None:
        self.on_click = google_chat_ros.msg.OnClick()
      if self.button is None:
        self.button = google_chat_ros.msg.Button()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.top_label = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.top_label = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.content = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.content = str[start:end]
      start = end
      end += 1
      (self.content_multiline,) = _get_struct_B().unpack(str[start:end])
      self.content_multiline = bool(self.content_multiline)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.bottom_label = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.bottom_label = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.on_click.action.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.on_click.action.action_method_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.on_click.action.parameters = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.ActionParameter()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.on_click.action.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.on_click.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.on_click.open_link_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.icon = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.icon = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.original_icon_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.original_icon_localpath = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.original_icon_localpath = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.text_button_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.text_button_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.text_button_on_click.action.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.text_button_on_click.action.action_method_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.button.text_button_on_click.action.parameters = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.ActionParameter()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.button.text_button_on_click.action.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.text_button_on_click.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.text_button_on_click.open_link_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.image_button_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.image_button_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.image_button_on_click.action.action_method_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.image_button_on_click.action.action_method_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.button.image_button_on_click.action.parameters = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.ActionParameter()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.button.image_button_on_click.action.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.image_button_on_click.open_link_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.image_button_on_click.open_link_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.icon = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.icon = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.original_icon_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.original_icon_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.button.original_icon_filepath = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.button.original_icon_filepath = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
