# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from google_chat_ros/Message.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import google_chat_ros.msg

class Message(genpy.Message):
  _md5sum = "74482e9e8af0e668f3b70e9af9ccd33f"
  _type = "google_chat_ros/Message"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """string name # Resource name in form spaces/*/messages/*
google_chat_ros/User sender # The user who created the message
string create_time # The time at which the message was created in Google Chat server
string text # Plain-text body of the message
string thread_name # The thread the message belongs to
google_chat_ros/Annotation[] annotations # Annotations associated with the plain-text body of the message
string argument_text # Plain-text body of the message with all bot mentions stripped out
google_chat_ros/Attachment[] attachments # User uploaded attachment

================================================================================
MSG: google_chat_ros/User
string name
string display_name
string avatar_url
uint8[] avatar
string email
bool bot
bool human

================================================================================
MSG: google_chat_ros/Annotation
int32 length
int32 start_index
google_chat_ros/User user
## START AnnotationType ##
bool mention
bool slash_command
### END AnnotationType ###
google_chat_ros/SlashCommand command

================================================================================
MSG: google_chat_ros/SlashCommand
google_chat_ros/User user
bool added
bool invoke
string command_name
string command_id
bool triggers_dialog

================================================================================
MSG: google_chat_ros/Attachment
string name
string content_name
string content_type
string thumnail_uri
string download_uri
string localpath
bool drive_file
bool uploaded_content
string attachment_resource_name
string drive_field_id
"""
  __slots__ = ['name','sender','create_time','text','thread_name','annotations','argument_text','attachments']
  _slot_types = ['string','google_chat_ros/User','string','string','string','google_chat_ros/Annotation[]','string','google_chat_ros/Attachment[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,sender,create_time,text,thread_name,annotations,argument_text,attachments

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Message, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.sender is None:
        self.sender = google_chat_ros.msg.User()
      if self.create_time is None:
        self.create_time = ''
      if self.text is None:
        self.text = ''
      if self.thread_name is None:
        self.thread_name = ''
      if self.annotations is None:
        self.annotations = []
      if self.argument_text is None:
        self.argument_text = ''
      if self.attachments is None:
        self.attachments = []
    else:
      self.name = ''
      self.sender = google_chat_ros.msg.User()
      self.create_time = ''
      self.text = ''
      self.thread_name = ''
      self.annotations = []
      self.argument_text = ''
      self.attachments = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.display_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.avatar_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.avatar
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.email
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.sender.bot, _x.sender.human))
      _x = self.create_time
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.thread_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.annotations)
      buff.write(_struct_I.pack(length))
      for val1 in self.annotations:
        _x = val1
        buff.write(_get_struct_2i().pack(_x.length, _x.start_index))
        _v1 = val1.user
        _x = _v1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.mention, _x.slash_command))
        _v2 = val1.command
        _v3 = _v2.user
        _x = _v3.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v3
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = _v2
        buff.write(_get_struct_2B().pack(_x.added, _x.invoke))
        _x = _v2.command_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v2.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v2.triggers_dialog
        buff.write(_get_struct_B().pack(_x))
      _x = self.argument_text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.attachments)
      buff.write(_struct_I.pack(length))
      for val1 in self.attachments:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.thumnail_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.download_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.localpath
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.drive_file, _x.uploaded_content))
        _x = val1.attachment_resource_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.drive_field_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.sender is None:
        self.sender = google_chat_ros.msg.User()
      if self.annotations is None:
        self.annotations = None
      if self.attachments is None:
        self.attachments = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.display_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.display_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.avatar_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.sender.avatar = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.email = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.email = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.sender.bot, _x.sender.human,) = _get_struct_2B().unpack(str[start:end])
      self.sender.bot = bool(self.sender.bot)
      self.sender.human = bool(self.sender.human)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.create_time = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.create_time = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.thread_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.thread_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.annotations = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Annotation()
        _x = val1
        start = end
        end += 8
        (_x.length, _x.start_index,) = _get_struct_2i().unpack(str[start:end])
        _v4 = val1.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v4.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v4.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v4.email = str[start:end]
        _x = _v4
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v4.bot = bool(_v4.bot)
        _v4.human = bool(_v4.human)
        _x = val1
        start = end
        end += 2
        (_x.mention, _x.slash_command,) = _get_struct_2B().unpack(str[start:end])
        val1.mention = bool(val1.mention)
        val1.slash_command = bool(val1.slash_command)
        _v5 = val1.command
        _v6 = _v5.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v6.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.email = str[start:end]
        _x = _v6
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v6.bot = bool(_v6.bot)
        _v6.human = bool(_v6.human)
        _x = _v5
        start = end
        end += 2
        (_x.added, _x.invoke,) = _get_struct_2B().unpack(str[start:end])
        _v5.added = bool(_v5.added)
        _v5.invoke = bool(_v5.invoke)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v5.command_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v5.command_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v5.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v5.command_id = str[start:end]
        start = end
        end += 1
        (_v5.triggers_dialog,) = _get_struct_B().unpack(str[start:end])
        _v5.triggers_dialog = bool(_v5.triggers_dialog)
        self.annotations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.argument_text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.argument_text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attachments = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Attachment()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.thumnail_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.thumnail_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.download_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.download_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.localpath = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.localpath = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.drive_file, _x.uploaded_content,) = _get_struct_2B().unpack(str[start:end])
        val1.drive_file = bool(val1.drive_file)
        val1.uploaded_content = bool(val1.uploaded_content)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.attachment_resource_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.attachment_resource_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.drive_field_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.drive_field_id = str[start:end]
        self.attachments.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.display_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.avatar_url
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.avatar
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.sender.email
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.sender.bot, _x.sender.human))
      _x = self.create_time
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.thread_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.annotations)
      buff.write(_struct_I.pack(length))
      for val1 in self.annotations:
        _x = val1
        buff.write(_get_struct_2i().pack(_x.length, _x.start_index))
        _v7 = val1.user
        _x = _v7.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v7.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v7.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v7.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v7.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v7
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.mention, _x.slash_command))
        _v8 = val1.command
        _v9 = _v8.user
        _x = _v9.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v9.display_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v9.avatar_url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v9.avatar
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v9.email
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v9
        buff.write(_get_struct_2B().pack(_x.bot, _x.human))
        _x = _v8
        buff.write(_get_struct_2B().pack(_x.added, _x.invoke))
        _x = _v8.command_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v8.command_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v8.triggers_dialog
        buff.write(_get_struct_B().pack(_x))
      _x = self.argument_text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.attachments)
      buff.write(_struct_I.pack(length))
      for val1 in self.attachments:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.content_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.thumnail_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.download_uri
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.localpath
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.drive_file, _x.uploaded_content))
        _x = val1.attachment_resource_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.drive_field_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.sender is None:
        self.sender = google_chat_ros.msg.User()
      if self.annotations is None:
        self.annotations = None
      if self.attachments is None:
        self.attachments = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.display_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.display_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.avatar_url = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.sender.avatar = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sender.email = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.sender.email = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.sender.bot, _x.sender.human,) = _get_struct_2B().unpack(str[start:end])
      self.sender.bot = bool(self.sender.bot)
      self.sender.human = bool(self.sender.human)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.create_time = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.create_time = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.thread_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.thread_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.annotations = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Annotation()
        _x = val1
        start = end
        end += 8
        (_x.length, _x.start_index,) = _get_struct_2i().unpack(str[start:end])
        _v10 = val1.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v10.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v10.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v10.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v10.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v10.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v10.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v10.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v10.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v10.email = str[start:end]
        _x = _v10
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v10.bot = bool(_v10.bot)
        _v10.human = bool(_v10.human)
        _x = val1
        start = end
        end += 2
        (_x.mention, _x.slash_command,) = _get_struct_2B().unpack(str[start:end])
        val1.mention = bool(val1.mention)
        val1.slash_command = bool(val1.slash_command)
        _v11 = val1.command
        _v12 = _v11.user
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v12.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v12.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v12.display_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v12.display_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v12.avatar_url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v12.avatar_url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v12.avatar = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v12.email = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v12.email = str[start:end]
        _x = _v12
        start = end
        end += 2
        (_x.bot, _x.human,) = _get_struct_2B().unpack(str[start:end])
        _v12.bot = bool(_v12.bot)
        _v12.human = bool(_v12.human)
        _x = _v11
        start = end
        end += 2
        (_x.added, _x.invoke,) = _get_struct_2B().unpack(str[start:end])
        _v11.added = bool(_v11.added)
        _v11.invoke = bool(_v11.invoke)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v11.command_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v11.command_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v11.command_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v11.command_id = str[start:end]
        start = end
        end += 1
        (_v11.triggers_dialog,) = _get_struct_B().unpack(str[start:end])
        _v11.triggers_dialog = bool(_v11.triggers_dialog)
        self.annotations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.argument_text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.argument_text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attachments = []
      for i in range(0, length):
        val1 = google_chat_ros.msg.Attachment()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.content_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.content_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.thumnail_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.thumnail_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.download_uri = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.download_uri = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.localpath = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.localpath = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.drive_file, _x.uploaded_content,) = _get_struct_2B().unpack(str[start:end])
        val1.drive_file = bool(val1.drive_file)
        val1.uploaded_content = bool(val1.uploaded_content)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.attachment_resource_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.attachment_resource_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.drive_field_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.drive_field_id = str[start:end]
        self.attachments.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
