// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CardHeader = require('./CardHeader.js');
let Section = require('./Section.js');
let CardAction = require('./CardAction.js');

//-----------------------------------------------------------

class Card {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.sections = null;
      this.card_actions = null;
      this.name = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new CardHeader();
      }
      if (initObj.hasOwnProperty('sections')) {
        this.sections = initObj.sections
      }
      else {
        this.sections = [];
      }
      if (initObj.hasOwnProperty('card_actions')) {
        this.card_actions = initObj.card_actions
      }
      else {
        this.card_actions = [];
      }
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Card
    // Serialize message field [header]
    bufferOffset = CardHeader.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [sections]
    // Serialize the length for message field [sections]
    bufferOffset = _serializer.uint32(obj.sections.length, buffer, bufferOffset);
    obj.sections.forEach((val) => {
      bufferOffset = Section.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [card_actions]
    // Serialize the length for message field [card_actions]
    bufferOffset = _serializer.uint32(obj.card_actions.length, buffer, bufferOffset);
    obj.card_actions.forEach((val) => {
      bufferOffset = CardAction.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Card
    let len;
    let data = new Card(null);
    // Deserialize message field [header]
    data.header = CardHeader.deserialize(buffer, bufferOffset);
    // Deserialize message field [sections]
    // Deserialize array length for message field [sections]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.sections = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.sections[i] = Section.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [card_actions]
    // Deserialize array length for message field [card_actions]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.card_actions = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.card_actions[i] = CardAction.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += CardHeader.getMessageSize(object.header);
    object.sections.forEach((val) => {
      length += Section.getMessageSize(val);
    });
    object.card_actions.forEach((val) => {
      length += CardAction.getMessageSize(val);
    });
    length += _getByteLength(object.name);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/Card';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'bb2b7c6880601ea58b79855bc615f5d1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    google_chat_ros/CardHeader header # The header of the card
    google_chat_ros/Section[] sections # Sections are separated by a line divider
    google_chat_ros/CardAction[] card_actions # The actions of this card
    string name # Name of the card
    
    ================================================================================
    MSG: google_chat_ros/CardHeader
    string title
    string subtitle
    bool image_style_circular # The image's type, makes border
    string image_url
    string image_filepath # The image in the card header
    
    ================================================================================
    MSG: google_chat_ros/Section
    string header # The header of the section
    google_chat_ros/WidgetMarkup[] widgets
    
    ================================================================================
    MSG: google_chat_ros/WidgetMarkup
    google_chat_ros/Button[] buttons
    string text_paragraph # Display a text paragraph in this widget
    google_chat_ros/Image image # Display an image in this widget
    google_chat_ros/KeyValue key_value # Display a key value item in this widget
    
    ================================================================================
    MSG: google_chat_ros/Button
    ### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
    # A button with text and onclick action
    string text_button_name 
    google_chat_ros/OnClick text_button_on_click
    # An image button with an onclick action
    string image_button_name
    google_chat_ros/OnClick image_button_on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_filepath # Original icon
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    ================================================================================
    MSG: google_chat_ros/Image
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/KeyValue
    string top_label # The text of the top label
    string content # The text of the content. Always required
    bool content_multiline # If the content should be multiline
    string bottom_label # The text of the bottom label
    google_chat_ros/OnClick on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
    google_chat_ros/Button button # A button that can be clicked to trigger an action
    
    ================================================================================
    MSG: google_chat_ros/CardAction
    string action_label # The label used to be displayed in the action menu item
    google_chat_ros/OnClick on_click
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Card(null);
    if (msg.header !== undefined) {
      resolved.header = CardHeader.Resolve(msg.header)
    }
    else {
      resolved.header = new CardHeader()
    }

    if (msg.sections !== undefined) {
      resolved.sections = new Array(msg.sections.length);
      for (let i = 0; i < resolved.sections.length; ++i) {
        resolved.sections[i] = Section.Resolve(msg.sections[i]);
      }
    }
    else {
      resolved.sections = []
    }

    if (msg.card_actions !== undefined) {
      resolved.card_actions = new Array(msg.card_actions.length);
      for (let i = 0; i < resolved.card_actions.length; ++i) {
        resolved.card_actions[i] = CardAction.Resolve(msg.card_actions[i]);
      }
    }
    else {
      resolved.card_actions = []
    }

    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    return resolved;
    }
};

module.exports = Card;
