// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let OnClick = require('./OnClick.js');

//-----------------------------------------------------------

class Image {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.image_url = null;
      this.localpath = null;
      this.on_click = null;
      this.aspect_ratio = null;
    }
    else {
      if (initObj.hasOwnProperty('image_url')) {
        this.image_url = initObj.image_url
      }
      else {
        this.image_url = '';
      }
      if (initObj.hasOwnProperty('localpath')) {
        this.localpath = initObj.localpath
      }
      else {
        this.localpath = '';
      }
      if (initObj.hasOwnProperty('on_click')) {
        this.on_click = initObj.on_click
      }
      else {
        this.on_click = new OnClick();
      }
      if (initObj.hasOwnProperty('aspect_ratio')) {
        this.aspect_ratio = initObj.aspect_ratio
      }
      else {
        this.aspect_ratio = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Image
    // Serialize message field [image_url]
    bufferOffset = _serializer.string(obj.image_url, buffer, bufferOffset);
    // Serialize message field [localpath]
    bufferOffset = _serializer.string(obj.localpath, buffer, bufferOffset);
    // Serialize message field [on_click]
    bufferOffset = OnClick.serialize(obj.on_click, buffer, bufferOffset);
    // Serialize message field [aspect_ratio]
    bufferOffset = _serializer.float64(obj.aspect_ratio, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Image
    let len;
    let data = new Image(null);
    // Deserialize message field [image_url]
    data.image_url = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [localpath]
    data.localpath = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [on_click]
    data.on_click = OnClick.deserialize(buffer, bufferOffset);
    // Deserialize message field [aspect_ratio]
    data.aspect_ratio = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.image_url);
    length += _getByteLength(object.localpath);
    length += OnClick.getMessageSize(object.on_click);
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/Image';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4ca7f9f879afc606650793149935a08e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Image(null);
    if (msg.image_url !== undefined) {
      resolved.image_url = msg.image_url;
    }
    else {
      resolved.image_url = ''
    }

    if (msg.localpath !== undefined) {
      resolved.localpath = msg.localpath;
    }
    else {
      resolved.localpath = ''
    }

    if (msg.on_click !== undefined) {
      resolved.on_click = OnClick.Resolve(msg.on_click)
    }
    else {
      resolved.on_click = new OnClick()
    }

    if (msg.aspect_ratio !== undefined) {
      resolved.aspect_ratio = msg.aspect_ratio;
    }
    else {
      resolved.aspect_ratio = 0.0
    }

    return resolved;
    }
};

module.exports = Image;
