// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let User = require('./User.js');
let Annotation = require('./Annotation.js');
let Attachment = require('./Attachment.js');

//-----------------------------------------------------------

class Message {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.sender = null;
      this.create_time = null;
      this.text = null;
      this.thread_name = null;
      this.annotations = null;
      this.argument_text = null;
      this.attachments = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('sender')) {
        this.sender = initObj.sender
      }
      else {
        this.sender = new User();
      }
      if (initObj.hasOwnProperty('create_time')) {
        this.create_time = initObj.create_time
      }
      else {
        this.create_time = '';
      }
      if (initObj.hasOwnProperty('text')) {
        this.text = initObj.text
      }
      else {
        this.text = '';
      }
      if (initObj.hasOwnProperty('thread_name')) {
        this.thread_name = initObj.thread_name
      }
      else {
        this.thread_name = '';
      }
      if (initObj.hasOwnProperty('annotations')) {
        this.annotations = initObj.annotations
      }
      else {
        this.annotations = [];
      }
      if (initObj.hasOwnProperty('argument_text')) {
        this.argument_text = initObj.argument_text
      }
      else {
        this.argument_text = '';
      }
      if (initObj.hasOwnProperty('attachments')) {
        this.attachments = initObj.attachments
      }
      else {
        this.attachments = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Message
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [sender]
    bufferOffset = User.serialize(obj.sender, buffer, bufferOffset);
    // Serialize message field [create_time]
    bufferOffset = _serializer.string(obj.create_time, buffer, bufferOffset);
    // Serialize message field [text]
    bufferOffset = _serializer.string(obj.text, buffer, bufferOffset);
    // Serialize message field [thread_name]
    bufferOffset = _serializer.string(obj.thread_name, buffer, bufferOffset);
    // Serialize message field [annotations]
    // Serialize the length for message field [annotations]
    bufferOffset = _serializer.uint32(obj.annotations.length, buffer, bufferOffset);
    obj.annotations.forEach((val) => {
      bufferOffset = Annotation.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [argument_text]
    bufferOffset = _serializer.string(obj.argument_text, buffer, bufferOffset);
    // Serialize message field [attachments]
    // Serialize the length for message field [attachments]
    bufferOffset = _serializer.uint32(obj.attachments.length, buffer, bufferOffset);
    obj.attachments.forEach((val) => {
      bufferOffset = Attachment.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Message
    let len;
    let data = new Message(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [sender]
    data.sender = User.deserialize(buffer, bufferOffset);
    // Deserialize message field [create_time]
    data.create_time = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [text]
    data.text = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [thread_name]
    data.thread_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [annotations]
    // Deserialize array length for message field [annotations]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.annotations = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.annotations[i] = Annotation.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [argument_text]
    data.argument_text = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [attachments]
    // Deserialize array length for message field [attachments]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.attachments = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.attachments[i] = Attachment.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.name);
    length += User.getMessageSize(object.sender);
    length += _getByteLength(object.create_time);
    length += _getByteLength(object.text);
    length += _getByteLength(object.thread_name);
    object.annotations.forEach((val) => {
      length += Annotation.getMessageSize(val);
    });
    length += _getByteLength(object.argument_text);
    object.attachments.forEach((val) => {
      length += Attachment.getMessageSize(val);
    });
    return length + 28;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/Message';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '74482e9e8af0e668f3b70e9af9ccd33f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string name # Resource name in form spaces/*/messages/*
    google_chat_ros/User sender # The user who created the message
    string create_time # The time at which the message was created in Google Chat server
    string text # Plain-text body of the message
    string thread_name # The thread the message belongs to
    google_chat_ros/Annotation[] annotations # Annotations associated with the plain-text body of the message
    string argument_text # Plain-text body of the message with all bot mentions stripped out
    google_chat_ros/Attachment[] attachments # User uploaded attachment
    
    ================================================================================
    MSG: google_chat_ros/User
    string name
    string display_name
    string avatar_url
    uint8[] avatar
    string email
    bool bot
    bool human
    
    ================================================================================
    MSG: google_chat_ros/Annotation
    int32 length
    int32 start_index
    google_chat_ros/User user
    ## START AnnotationType ##
    bool mention
    bool slash_command
    ### END AnnotationType ###
    google_chat_ros/SlashCommand command
    
    ================================================================================
    MSG: google_chat_ros/SlashCommand
    google_chat_ros/User user
    bool added
    bool invoke
    string command_name
    string command_id
    bool triggers_dialog
    
    ================================================================================
    MSG: google_chat_ros/Attachment
    string name
    string content_name
    string content_type
    string thumnail_uri
    string download_uri
    string localpath
    bool drive_file
    bool uploaded_content
    string attachment_resource_name
    string drive_field_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Message(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.sender !== undefined) {
      resolved.sender = User.Resolve(msg.sender)
    }
    else {
      resolved.sender = new User()
    }

    if (msg.create_time !== undefined) {
      resolved.create_time = msg.create_time;
    }
    else {
      resolved.create_time = ''
    }

    if (msg.text !== undefined) {
      resolved.text = msg.text;
    }
    else {
      resolved.text = ''
    }

    if (msg.thread_name !== undefined) {
      resolved.thread_name = msg.thread_name;
    }
    else {
      resolved.thread_name = ''
    }

    if (msg.annotations !== undefined) {
      resolved.annotations = new Array(msg.annotations.length);
      for (let i = 0; i < resolved.annotations.length; ++i) {
        resolved.annotations[i] = Annotation.Resolve(msg.annotations[i]);
      }
    }
    else {
      resolved.annotations = []
    }

    if (msg.argument_text !== undefined) {
      resolved.argument_text = msg.argument_text;
    }
    else {
      resolved.argument_text = ''
    }

    if (msg.attachments !== undefined) {
      resolved.attachments = new Array(msg.attachments.length);
      for (let i = 0; i < resolved.attachments.length; ++i) {
        resolved.attachments[i] = Attachment.Resolve(msg.attachments[i]);
      }
    }
    else {
      resolved.attachments = []
    }

    return resolved;
    }
};

module.exports = Message;
