// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SendMessageResult = require('./SendMessageResult.js');
let std_msgs = _finder('std_msgs');
let actionlib_msgs = _finder('actionlib_msgs');

//-----------------------------------------------------------

class SendMessageActionResult {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.status = null;
      this.result = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = new actionlib_msgs.msg.GoalStatus();
      }
      if (initObj.hasOwnProperty('result')) {
        this.result = initObj.result
      }
      else {
        this.result = new SendMessageResult();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SendMessageActionResult
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = actionlib_msgs.msg.GoalStatus.serialize(obj.status, buffer, bufferOffset);
    // Serialize message field [result]
    bufferOffset = SendMessageResult.serialize(obj.result, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SendMessageActionResult
    let len;
    let data = new SendMessageActionResult(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = actionlib_msgs.msg.GoalStatus.deserialize(buffer, bufferOffset);
    // Deserialize message field [result]
    data.result = SendMessageResult.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += actionlib_msgs.msg.GoalStatus.getMessageSize(object.status);
    length += SendMessageResult.getMessageSize(object.result);
    return length;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/SendMessageActionResult';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e6ea81f96b7558d651e042ed81283a6e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    Header header
    actionlib_msgs/GoalStatus status
    SendMessageResult result
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: actionlib_msgs/GoalStatus
    GoalID goal_id
    uint8 status
    uint8 PENDING         = 0   # The goal has yet to be processed by the action server
    uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
    uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                                #   and has since completed its execution (Terminal State)
    uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
    uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                                #    to some failure (Terminal State)
    uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                                #    because the goal was unattainable or invalid (Terminal State)
    uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                                #    and has not yet completed execution
    uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                                #    but the action server has not yet confirmed that the goal is canceled
    uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                                #    and was successfully cancelled (Terminal State)
    uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                                #    sent over the wire by an action server
    
    #Allow for the user to associate a string with GoalStatus for debugging
    string text
    
    
    ================================================================================
    MSG: actionlib_msgs/GoalID
    # The stamp should store the time at which this goal was requested.
    # It is used by an action server when it tries to preempt all
    # goals that were requested before a certain time
    time stamp
    
    # The id provides a way to associate feedback and
    # result message with specific goal requests. The id
    # specified must be unique.
    string id
    
    
    ================================================================================
    MSG: google_chat_ros/SendMessageResult
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Define the result
    google_chat_ros/Message message_result
    google_chat_ros/Card[] cards_result
    bool done
    
    ================================================================================
    MSG: google_chat_ros/Message
    string name # Resource name in form spaces/*/messages/*
    google_chat_ros/User sender # The user who created the message
    string create_time # The time at which the message was created in Google Chat server
    string text # Plain-text body of the message
    string thread_name # The thread the message belongs to
    google_chat_ros/Annotation[] annotations # Annotations associated with the plain-text body of the message
    string argument_text # Plain-text body of the message with all bot mentions stripped out
    google_chat_ros/Attachment[] attachments # User uploaded attachment
    
    ================================================================================
    MSG: google_chat_ros/User
    string name
    string display_name
    string avatar_url
    uint8[] avatar
    string email
    bool bot
    bool human
    
    ================================================================================
    MSG: google_chat_ros/Annotation
    int32 length
    int32 start_index
    google_chat_ros/User user
    ## START AnnotationType ##
    bool mention
    bool slash_command
    ### END AnnotationType ###
    google_chat_ros/SlashCommand command
    
    ================================================================================
    MSG: google_chat_ros/SlashCommand
    google_chat_ros/User user
    bool added
    bool invoke
    string command_name
    string command_id
    bool triggers_dialog
    
    ================================================================================
    MSG: google_chat_ros/Attachment
    string name
    string content_name
    string content_type
    string thumnail_uri
    string download_uri
    string localpath
    bool drive_file
    bool uploaded_content
    string attachment_resource_name
    string drive_field_id
    
    ================================================================================
    MSG: google_chat_ros/Card
    google_chat_ros/CardHeader header # The header of the card
    google_chat_ros/Section[] sections # Sections are separated by a line divider
    google_chat_ros/CardAction[] card_actions # The actions of this card
    string name # Name of the card
    
    ================================================================================
    MSG: google_chat_ros/CardHeader
    string title
    string subtitle
    bool image_style_circular # The image's type, makes border
    string image_url
    string image_filepath # The image in the card header
    
    ================================================================================
    MSG: google_chat_ros/Section
    string header # The header of the section
    google_chat_ros/WidgetMarkup[] widgets
    
    ================================================================================
    MSG: google_chat_ros/WidgetMarkup
    google_chat_ros/Button[] buttons
    string text_paragraph # Display a text paragraph in this widget
    google_chat_ros/Image image # Display an image in this widget
    google_chat_ros/KeyValue key_value # Display a key value item in this widget
    
    ================================================================================
    MSG: google_chat_ros/Button
    ### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
    # A button with text and onclick action
    string text_button_name 
    google_chat_ros/OnClick text_button_on_click
    # An image button with an onclick action
    string image_button_name
    google_chat_ros/OnClick image_button_on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_filepath # Original icon
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    ================================================================================
    MSG: google_chat_ros/Image
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/KeyValue
    string top_label # The text of the top label
    string content # The text of the content. Always required
    bool content_multiline # If the content should be multiline
    string bottom_label # The text of the bottom label
    google_chat_ros/OnClick on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
    google_chat_ros/Button button # A button that can be clicked to trigger an action
    
    ================================================================================
    MSG: google_chat_ros/CardAction
    string action_label # The label used to be displayed in the action menu item
    google_chat_ros/OnClick on_click
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SendMessageActionResult(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.status !== undefined) {
      resolved.status = actionlib_msgs.msg.GoalStatus.Resolve(msg.status)
    }
    else {
      resolved.status = new actionlib_msgs.msg.GoalStatus()
    }

    if (msg.result !== undefined) {
      resolved.result = SendMessageResult.Resolve(msg.result)
    }
    else {
      resolved.result = new SendMessageResult()
    }

    return resolved;
    }
};

module.exports = SendMessageActionResult;
