// Auto-generated. Do not edit!

// (in-package google_chat_ros.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Button = require('./Button.js');
let Image = require('./Image.js');
let KeyValue = require('./KeyValue.js');

//-----------------------------------------------------------

class WidgetMarkup {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.buttons = null;
      this.text_paragraph = null;
      this.image = null;
      this.key_value = null;
    }
    else {
      if (initObj.hasOwnProperty('buttons')) {
        this.buttons = initObj.buttons
      }
      else {
        this.buttons = [];
      }
      if (initObj.hasOwnProperty('text_paragraph')) {
        this.text_paragraph = initObj.text_paragraph
      }
      else {
        this.text_paragraph = '';
      }
      if (initObj.hasOwnProperty('image')) {
        this.image = initObj.image
      }
      else {
        this.image = new Image();
      }
      if (initObj.hasOwnProperty('key_value')) {
        this.key_value = initObj.key_value
      }
      else {
        this.key_value = new KeyValue();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type WidgetMarkup
    // Serialize message field [buttons]
    // Serialize the length for message field [buttons]
    bufferOffset = _serializer.uint32(obj.buttons.length, buffer, bufferOffset);
    obj.buttons.forEach((val) => {
      bufferOffset = Button.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [text_paragraph]
    bufferOffset = _serializer.string(obj.text_paragraph, buffer, bufferOffset);
    // Serialize message field [image]
    bufferOffset = Image.serialize(obj.image, buffer, bufferOffset);
    // Serialize message field [key_value]
    bufferOffset = KeyValue.serialize(obj.key_value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type WidgetMarkup
    let len;
    let data = new WidgetMarkup(null);
    // Deserialize message field [buttons]
    // Deserialize array length for message field [buttons]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.buttons = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.buttons[i] = Button.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [text_paragraph]
    data.text_paragraph = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [image]
    data.image = Image.deserialize(buffer, bufferOffset);
    // Deserialize message field [key_value]
    data.key_value = KeyValue.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.buttons.forEach((val) => {
      length += Button.getMessageSize(val);
    });
    length += _getByteLength(object.text_paragraph);
    length += Image.getMessageSize(object.image);
    length += KeyValue.getMessageSize(object.key_value);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'google_chat_ros/WidgetMarkup';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'df2ae4247b1cbe16ca432a0ead1ba903';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    google_chat_ros/Button[] buttons
    string text_paragraph # Display a text paragraph in this widget
    google_chat_ros/Image image # Display an image in this widget
    google_chat_ros/KeyValue key_value # Display a key value item in this widget
    
    ================================================================================
    MSG: google_chat_ros/Button
    ### FIELD DATA CAN BE ONLY ONE OF THE TEXT BUTTON OR IMAGE BUTTON ###
    # A button with text and onclick action
    string text_button_name 
    google_chat_ros/OnClick text_button_on_click
    # An image button with an onclick action
    string image_button_name
    google_chat_ros/OnClick image_button_on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_filepath # Original icon
    
    ================================================================================
    MSG: google_chat_ros/OnClick
    ### FIELD DATA CAN BE ONLY ONE OF THE FOLLOWING ###
    google_chat_ros/FormAction action # A form action will be triggered by this onclick if specified
    string open_link_url # A link that opens a new window
    
    ================================================================================
    MSG: google_chat_ros/FormAction
    # The form action data associated with an interactive card that was clicked. Only populated for CARD_CLICKED events.
    string action_method_name
    google_chat_ros/ActionParameter[] parameters
    
    ================================================================================
    MSG: google_chat_ros/ActionParameter
    string key
    string value
    
    ================================================================================
    MSG: google_chat_ros/Image
    string image_url
    string localpath # If you want to upload new image on google drive, please set this element, not image_uri.
    google_chat_ros/OnClick on_click
    float64 aspect_ratio # The aspect ratio of this image (width/height). If unset, the server fills it by prefetching the image
    
    ================================================================================
    MSG: google_chat_ros/KeyValue
    string top_label # The text of the top label
    string content # The text of the content. Always required
    bool content_multiline # If the content should be multiline
    string bottom_label # The text of the bottom label
    google_chat_ros/OnClick on_click
    string icon # see https://developers.google.com/chat/api/reference/rest/v1/cards#icon
    string original_icon_url # Original icon image's url
    string original_icon_localpath # If you want to upload new image on google drive, please set this element, not original_icon_url.
    google_chat_ros/Button button # A button that can be clicked to trigger an action
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new WidgetMarkup(null);
    if (msg.buttons !== undefined) {
      resolved.buttons = new Array(msg.buttons.length);
      for (let i = 0; i < resolved.buttons.length; ++i) {
        resolved.buttons[i] = Button.Resolve(msg.buttons[i]);
      }
    }
    else {
      resolved.buttons = []
    }

    if (msg.text_paragraph !== undefined) {
      resolved.text_paragraph = msg.text_paragraph;
    }
    else {
      resolved.text_paragraph = ''
    }

    if (msg.image !== undefined) {
      resolved.image = Image.Resolve(msg.image)
    }
    else {
      resolved.image = new Image()
    }

    if (msg.key_value !== undefined) {
      resolved.key_value = KeyValue.Resolve(msg.key_value)
    }
    else {
      resolved.key_value = new KeyValue()
    }

    return resolved;
    }
};

module.exports = WidgetMarkup;
